using System;

namespace Rsdn.SmartApp.Demos
{
	using FruitSvc = IRegElementsService<FruitInfo>;
	using KeyedFruitSvc = IRegKeyedElementsService<string, FruitInfo>;

	internal class Program
	{
		static void Main()
		{
			ExtensionManager extMgr = new ExtensionManager(null);
			Type[] types = typeof(Program).Assembly.GetTypes();

			// Elements registration
			ServiceManager regSvcMgr = new ServiceManager();
			extMgr.Scan(types, new RegFruitStrategy(regSvcMgr));
			FruitSvc fruitSvc = regSvcMgr.GetService<FruitSvc>();
			foreach (FruitInfo fi in fruitSvc.GetRegisteredElements())
				Console.WriteLine("{0}({1})", fi.Name, fi.Type);

			// Keyed elements registration
			ServiceManager keyedRegSvcMgr = new ServiceManager();
			extMgr.Scan(types, new RegKeyedFruitStrategy(keyedRegSvcMgr));
			KeyedFruitSvc keyedFruitSvc = keyedRegSvcMgr.GetService<KeyedFruitSvc>();
			Console.WriteLine("lemon type is '{0}'",
				keyedFruitSvc.GetElement("lemon").Type);

			Console.Read();
		}
	}
}
