﻿namespace Rsdn.SmartApp
{
	/// <summary>
	/// Стратегия регистрации active parts.
	/// </summary>
	public class ActivePartRegStrategy
		: RegKeyedElementsStrategy<string, ActivePartInfo, ActivePartAttribute>
	{
		/// <include file='../CommonXmlDocs.xml' path='common-docs/def-ctor/*'/>
		public ActivePartRegStrategy(IServicePublisher publisher) : base(publisher)
		{}

		/// <summary>
		/// Создать описатель.
		/// </summary>
		public override ActivePartInfo CreateElement(
			IExtensionAttachmentContext context,
			ActivePartAttribute attr)
		{
			return new ActivePartInfo(attr.Name, context.ExtensionType);
		}
	}
}
