using System;

namespace Rsdn.SmartApp
{
	/// <summary>
	///   .
	/// </summary>
	public abstract class AttachmentStrategyBase : IExtensionAttachmentStrategy
	{
		private readonly Type[] _supportedAttrTypes;

		/// <summary>
		///  .
		/// </summary>
		public AttachmentStrategyBase(params Type[] supportedAttrTypes)
		{
			_supportedAttrTypes = supportedAttrTypes;
		}

		/// <summary>
		///   .
		/// </summary>
		protected Type[] SupportedAttrTypes
		{
			get { return _supportedAttrTypes; }
		}

		void IExtensionAttachmentStrategy.Attach(IExtensionAttachmentContext context,
			Attribute attribute)
		{
			foreach (Type t in SupportedAttrTypes)
				if (t.IsAssignableFrom(attribute.GetType()))
				{
					Attach(context, attribute);
					return;
				}
		}

		/// <summary>
		///  .
		/// </summary>
		protected abstract void Attach(IExtensionAttachmentContext context,
			Attribute attribute);
	}
}
