using System;

namespace Rsdn.SmartApp
{
	/// <summary>
	///      .
	/// </summary>
	public abstract class RegKeyedElementsStrategy<K, EI, A>
		: RegElementsStrategy<EI, A>, IExtensionAttachmentStrategy
		where A : Attribute
		where EI : IKeyedElementInfo<K>
	{
		/// <summary>
		///  .
		/// </summary>
		protected RegKeyedElementsStrategy(IServicePublisher publisher)
			: base(publisher)
		{ }

		/// <summary>
		///  .
		/// </summary>
		protected override void Attach(IExtensionAttachmentContext context, A attribute)
		{
			base.Attach(context, attribute);
			CheckService();
		}

		/// <summary>
		///   .
		/// </summary>
		protected override IRegElementsService<EI> CreateService(
			IExtensionAttachmentContext context, A attr)
		{
			return new RegKeyedElementsService<K, EI>();
		}

		private void CheckService()
		{
			IRegKeyedElementsService<K, EI> regSvc =
				Publisher.GetService<IRegKeyedElementsService<K, EI>>();
			if (regSvc == null)
			{
				regSvc = (IRegKeyedElementsService<K, EI>)Publisher.GetService<IRegElementsService<EI>>();
				Publisher.Publish<IRegKeyedElementsService<K, EI>>(regSvc);
			}
		}
	}
}
