﻿using System;

namespace Rsdn.SmartApp
{
	/// <summary>
	/// Помечает active part класс.
	/// </summary>
	public class ActivePartAttribute : Attribute
	{
		/// <summary>
		/// Инициализирует экземпляр.
		/// </summary>
		/// <param name="name"></param>
		public ActivePartAttribute(string name)
		{
			if (string.IsNullOrEmpty(name) || name.Trim() == "")
				throw new ArgumentNullException("name");
			Name = name;
		}

		/// <summary>
		/// Имя.
		/// </summary>
		public string Name { get; private set; }
	}
}
