using System;

using Rsdn.SmartApp;

namespace Rsdn.SmartApp
{
	/// <summary>
	///  active part.
	/// </summary>
	public class ActivePartInfo : IKeyedElementInfo<string>
	{
		/// <summary>
		///  .
		/// </summary>
		public ActivePartInfo(string name, Type type)
		{
			if (string.IsNullOrEmpty(name))
				throw new ArgumentNullException("name");
			if (type == null)
				throw new ArgumentNullException("type");

			Name = name;
			Type = type;
		}

		/// <summary>
		///  .
		/// </summary>
		public string Name
		{
			get;
			private set;
		}

		/// <summary>
		/// ,  .
		/// </summary>
		public Type Type
		{
			get;
			private set;
		}

		#region IKeyedElementInfo<string> Members
		/// <summary>
		/// .
		/// </summary>
		string IKeyedElementInfo<string>.Key
		{
			get { return Name; }
		}
		#endregion
	}
}
