﻿using System;
namespace Rsdn.SmartApp
{
	/// <summary>
	/// Менеджер active parts.
	/// </summary>
	public interface IActivePartManager
	{
		/// <summary>
		/// Возвращает признак регистрации по имени.
		/// </summary>
		bool IsPartRegistered(string name);

		/// <summary>
		/// Возвращает тип active part.
		/// </summary>
		Type GetPartType(string name);

		/// <summary>
		/// Получить экземпляр active part.
		/// </summary>
		object GetPartInstance(string name);
	}
}
