using System;

namespace Rsdn.SmartApp
{
	[AttributeUsage(AttributeTargets.Class)]
	public class DisableRegAttribute : Attribute, IScanFilterAttribute
	{
		private readonly string _disableName;

		public DisableRegAttribute(string disableName)
		{
			_disableName = disableName;
		}

		/// <summary>
		///  true,     .
		/// </summary>
		public bool AllowAttach(IExtensionAttachmentContext context,
			Attribute attribute)
		{
			NamedElementAttribute nae = attribute as NamedElementAttribute;
			return nae == null || nae.Name != _disableName;
		}
	}
}
